﻿/// <reference path="utils.js" />

var myGridPopup;
var myDataViewPopup;
var columnFilters = {};
var columns = [
					{ id: "Id", name: "Id", field: "Id", sortable: true },
					{ id: "Name", name: "Name", field: "Name", sortable: true }
                ];

var sortcol = "Id";
var sortdir = 1;

var options = {
    enableCellNavigation: true,
    enableColumnReorder: false,
    forceFitColumns: true,
    multiSelect: false,
    explicitInitialization: true
};

$(function () {
    LoadData();

    $("#btnOk").click(function myfunction() {
        //as we have disabled multiselect, we would get only one row index.
        var selectedGridData = myGridPopup.getData().getItem(myGridPopup.getSelectedRows()[0]);
        var selectedId = selectedGridData.Id;
        var selectedName = selectedGridData.Name;
        var closestParent = $(this).closest("div.ui-subdialog-content");
        var ctrlToBePopulated = closestParent.data("subDialogParams").controlToBePopulated;
        $(closestParent).dialog('close');
        if (ctrlToBePopulated.val() != selectedName) {
            ctrlToBePopulated.val(selectedName);
            ctrlToBePopulated.data("myId", selectedId);
        }
    });

    //Cancel button click
    $("#btnCancel").click(function myfunction() {
        var closestParent = $(this).closest("div.ui-subdialog-content");
        $(closestParent).dialog('close');
    });
});

function LoadData() {
    callAction('/Home/GetPopupData', '', '', 'POST', 'json', onSuccessLoadData);
    //The following function is wrapped up as callAction in utils.js
    /*
    var myData = [];
    $.ajax({
    cache: false,
    dataType: "json",
    url: "/Home/GetPopupData",
    success: function (data) {
    myData = data;
    CreateGridPopup(myData);
    SetDefaultIdSelectedPopup();
    },
    error: function () {
    alert("Error.");
    });
    */
}

function onSuccessLoadData(data) {
    var resultData = [];
    resultData = data;
    CreateGridPopup(resultData);
    SetDefaultIdSelectedPopup();
    /* 
    We are saving the grid instance in 'sgPopupGrid' variable 
    as we would need to destroy this on close of this popup.
    */
    $("#myGridPopup").data('sgPopupGrid', myGridPopup);
}

function SetDefaultIdSelectedPopup() {
    var closestParent = $("#myGridPopup").closest("div.ui-subdialog-content");
    if (closestParent.data("subDialogParams")) {
        var ctrlToBePopulated = closestParent.data("subDialogParams").controlToBePopulated;
        var selectedId = ctrlToBePopulated.data("myId");
        if (selectedId != null && selectedId != undefined && selectedId > 0) {
            for (var rowIndex = 0; rowIndex < myDataViewPopup.getLength(); rowIndex++) {
                var gridRow = myDataViewPopup.getItem(rowIndex);
                if (gridRow.Id === selectedId) {
                    myGridPopup.setSelectedRows([rowIndex]);
                    $("#btnOk").prop("disabled", false);
                    //TODO: check why the scrollRowIntoView is not working
                    myGridPopup.scrollRowIntoView(rowIndex);
                    break;
                }
            }
        }
    }
}

function CreateGridPopup(resultData) {
    // Create the DataView.
    myDataViewPopup = new Slick.Data.DataView();
    //myDataViewPopup = new Slick.Data.DataView();

    //Create new slick myGridPopup
    myGridPopup = new Slick.Grid("#myGridPopup", myDataViewPopup, columns, options);

    //#region DataView default events
    // wire up model events to drive the myGridPopup
    myDataViewPopup.onRowCountChanged.subscribe(function (e, args) {
        myGridPopup.updateRowCount();
        myGridPopup.render();
    });

    myDataViewPopup.onRowsChanged.subscribe(function (e, args) {
        myGridPopup.invalidateRows(args.rows);
        myGridPopup.render();
    });
    //#endregion

    //Enable row selection
    myGridPopup.setSelectionModel(new Slick.RowSelectionModel());

    myGridPopup.onClick.subscribe(function (e) {
        var cell = myGridPopup.getCellFromEvent(e);
        myGridPopup.setSelectedRows([cell.row]);
        var selectedIndicesArray = myGridPopup.getSelectedRows();
        //as we have disabled multiselect, we would get only one row index.
        var selectedRow = myGridPopup.getData().getItem(selectedIndicesArray[0]);
        $("#btnOk").prop("disabled", false);
    });

    //Sort
    myGridPopup.onSort.subscribe(function (e, args) {
        sortdir = args.sortAsc ? 1 : -1;
        sortcol = args.sortCol.field;
        // Delegate the sorting to DataView.
        // This will fire the change events and update the myGridPopup.
        myDataViewPopup.sort(comparer, args.sortAsc);
    });

    //Explicit initilization
    myGridPopup.init();

    // initialize the model after all the events have been hooked up
    myDataViewPopup.beginUpdate();

    // Feed the data into the dataview
    myDataViewPopup.setItems(resultData, "Id");

    myDataViewPopup.endUpdate();
    // if you don't want the items that are not visible (due to being filtered out
    // or being on a different page) to stay selected, pass 'false' to the second arg
    myDataViewPopup.syncGridSelection(myGridPopup, true);
}

function comparer(a, b) {
    var x = a[sortcol], y = b[sortcol];
    return (x == y ? 0 : (x > y ? 1 : -1));
}